import sreb

class CustomClassTemplate(sreb.EBObject):
    def __init__(self):
        sreb.EBObject.__init__(self)
        #NB!
        #Property1 holds the session name if you do this: 
        #Put =@parent.sessionName@ into property1 of the custom class instance attributes.
        self.property1=""    
        
    #Property: property1
    #A read and write string type property
    def setProperty1(self,c):
        self.property1=c
    
    def getProperty1(self):
        return self.property1
        
    #Callable method using Execute action.  
    #Note the default arguments and the doc string to let eb know what is the expected return type.
    def myMethod(self):
        """RETURN:int"""
        #The first line of the doc of method is used to get the return type of the method.

        # Damm code from https://en.wikibooks.org/wiki/Algorithm_Implementation/Checksums/Damm_Algorithm#Python
        # For reference see https://en.wikipedia.org/wiki/Damm_algorithm
        
        matrix = (
            (0, 3, 1, 7, 5, 9, 8, 6, 4, 2),
            (7, 0, 9, 2, 1, 5, 4, 8, 6, 3),
            (4, 2, 0, 6, 8, 7, 1, 3, 5, 9),
            (1, 7, 5, 0, 9, 8, 3, 4, 2, 6),
            (6, 1, 2, 3, 0, 4, 5, 9, 7, 8),
            (3, 6, 7, 4, 2, 0, 9, 5, 8, 1),
            (5, 8, 6, 9, 7, 2, 0, 1, 3, 4),
            (8, 9, 4, 5, 3, 6, 2, 0, 1, 7),
            (9, 4, 3, 8, 6, 1, 7, 2, 0, 5),
            (2, 5, 8, 1, 4, 3, 6, 7, 9, 0)
        )
        
        def encode(number):
            number = str(number)
            interim = 0   
            for digit in number:
                interim = matrix[interim][int(digit)]
            return interim
            
        def check(number):
            return encode(number) == 0
        
        
        def validate_participant_ID(id):
            # quick sanity checking (from wikibooks)
            assert encode(572) == 4 # from wikipedia
            assert check(5724)
            assert encode('43881234567') == 9 # hand-computed
            
            #Actual validation
            id = id.replace('\n','').replace('NO','')
            result = check(id)
            return result


        id = self.getProperty1()  #Property1 holds the session name
        result = validate_participant_ID(id)
        if result == True:
            return 1
        else:
            return 0